/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-document-manager.h -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _IANJUTA_DOCUMENT_MANAGER_H_
#define _IANJUTA_DOCUMENT_MANAGER_H_

#include <glib-object.h>
#include <libanjuta/interfaces/ianjuta-editor.h>

G_BEGIN_DECLS

#define IANJUTA_TYPE_DOCUMENT_MANAGER (ianjuta_document_manager_get_type ())
#define IANJUTA_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IANJUTA_TYPE_DOCUMENT_MANAGER, IAnjutaDocumentManager))
#define IANJUTA_IS_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IANJUTA_TYPE_DOCUMENT_MANAGER))
#define IANJUTA_DOCUMENT_MANAGER_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), IANJUTA_TYPE_DOCUMENT_MANAGER, IAnjutaDocumentManagerIface))

#define IANJUTA_TYPE_DOCUMENT_MANAGER_ERROR (ianjuta_document_manager_error_get_type())

typedef enum {
	IANJUTA_DOCUMENT_MANAGER_DOESNT_EXIST
} IAnjutaDocumentManagerError;

#define IANJUTA_DOCUMENT_MANAGER_ERROR ianjuta_document_manager_error_quark()

typedef struct _IAnjutaDocumentManager IAnjutaDocumentManager;
typedef struct _IAnjutaDocumentManagerIface IAnjutaDocumentManagerIface;

struct _IAnjutaDocumentManagerIface {
	GTypeInterface g_iface;
	

	IAnjutaEditor* (*add_buffer) (IAnjutaDocumentManager *obj, const gchar *name, const gchar* content, GError **err);
	IAnjutaEditor* (*find_editor_with_path) (IAnjutaDocumentManager *obj, const gchar *file_path, GError **err);
	IAnjutaEditor* (*get_current_editor) (IAnjutaDocumentManager *obj, GError **err);
	GList* (*get_editors) (IAnjutaDocumentManager *obj, GError **err);
	const gchar * (*get_full_filename) (IAnjutaDocumentManager *obj, const gchar *file, GError **err);
	void (*goto_file_line) (IAnjutaDocumentManager *obj, const gchar *file, gint lineno, GError **err);
	void (*goto_file_line_mark) (IAnjutaDocumentManager *obj, const gchar *file, gint lineno, gboolean mark, GError **err);
	void (*set_current_editor) (IAnjutaDocumentManager *obj, IAnjutaEditor *editor, GError **err);

};
GType ianjuta_document_manager_error_get_type (void);

GQuark ianjuta_document_manager_error_quark     (void);
GType  ianjuta_document_manager_get_type        (void);

IAnjutaEditor* ianjuta_document_manager_add_buffer (IAnjutaDocumentManager *obj, const gchar *name, const gchar* content, GError **err);

IAnjutaEditor* ianjuta_document_manager_find_editor_with_path (IAnjutaDocumentManager *obj, const gchar *file_path, GError **err);

IAnjutaEditor* ianjuta_document_manager_get_current_editor (IAnjutaDocumentManager *obj, GError **err);

GList* ianjuta_document_manager_get_editors (IAnjutaDocumentManager *obj, GError **err);

const gchar * ianjuta_document_manager_get_full_filename (IAnjutaDocumentManager *obj, const gchar *file, GError **err);

void ianjuta_document_manager_goto_file_line (IAnjutaDocumentManager *obj, const gchar *file, gint lineno, GError **err);

void ianjuta_document_manager_goto_file_line_mark (IAnjutaDocumentManager *obj, const gchar *file, gint lineno, gboolean mark, GError **err);

void ianjuta_document_manager_set_current_editor (IAnjutaDocumentManager *obj, IAnjutaEditor *editor, GError **err);


G_END_DECLS

#endif
